class GameObj {
  constructor(name) {
    this.name = name;
  }

  move() {
    console.log(`${this.name}进行了移动`);
  }
}

// NPC 子类
class NPC extends GameObj {
  constructor(name, title) {
    super(name);
    this.title = title;
    this.name = `${name}`;
  }

  talk() {
    console.log(`${this.title}头衔的${this.name}进行了说话`);
  }
}

// Enemy 子类
class Enemy extends GameObj {
  constructor(name, hp) {
    super(name);
    this.hp = hp;
    this.name = `${name}`;
  }

  attack() {
    console.log(`${this.hp}血量的${this.name}进行了攻击`);
  }
}

module.exports = { GameObj, NPC, Enemy };
